/*
 *    A file of basic additions and modifications to the default adv.t,
 *    std.t, extend.t, and other third-party add-ons to TADS.
 *
 *    Basic library, Copyright (c) 2003 by Quintin Stone.  All Rights Reserved.
 */

#include "use.t"

compoundWord 'fuck' 'you' 'fuckyou';
compoundWord 'fuck' 'off' 'fuckyou';
compoundWord 'get' 'out' 'getout';

/*
 *	First, the modified classes
 */

modify global
	dispParagraph = "\b"
	showedParagraph = nil
	showParagraph = {
		if (!self.showedParagraph) {
			self.showedParagraph := true;
			self.dispParagraph;
		}
	}
	aboutbox = ""
	addthis = 0
    score = 0

	// Modified from extend.t to cover score loss
	tellscore={
		if (self.addthis > 0) {
			"<<global.dispParagraph>>[Your score has just gone up by <<self.addthis>> point";
			if (self.addthis > 1)
				"s";
			".] ";
		} else {
			self.addthis := -self.addthis;
			"<<global.dispParagraph>>[Your score has just gone down by <<self.addthis>> point";
			if (self.addthis > 1)
				"s";
			".] ";
		}
		self.addthis := 0;
	}
;

modify thing
	bulkthresh = 20
	takeMessage="Taken. "
	verDoShowTo(actor, io) =
	{
		if (!self.isIn(actor))
			"You're not carrying it. ";
	}
	verDoPutUnder(actor, io) = {
	}
	verIoPutUnder(actor) =
	{
		"There isn't room. ";
	}
	verIoTakeWith(actor) =
	{
		"I don't see how that would help. ";
	}
	verIoPushWith(actor) =
	{
	}
	verDoPushWith(actor, iobj) = {
		self.verDoPush(actor);
	}
	ioPushWith(actor, dobj) = {
		dobj.doPush(actor);
	}
	verDoTakeWith(actor, obj) = {}
	showsurface = {
		"Sitting on "; self.thedesc;" is "; listcont(self); ". ";
	}
	verIoTouchTo(actor) = {}
	ioTouchTo(actor, dobj) = {
		"Nothing happens. ";
	}
	verDoAttack(actor) = {}
	doAttack(actor) = {
		"Your fists do little damage. ";
	}
	verDoTouchTo(actor, io) = {}
	verDoKiss(actor) = {
		"You really want to put your lips on that? ";
	}
	verDoRape(actor) = {
		"That sounds like an unpleasant experience. ";
	}
	doShowTo(actor, io) =
	{
		io.ioShowTo(actor, self);
	}
	ioShowTo(actor, dobj) = {
		caps(); self.thedesc; " "; self.isntdesc; " impressed. ";
	}
	verDoSay(actor) =
	{
		"If you wish to speak to someone, you can address them directly.  For example: <B>JOHN, HELLO</B>";
	}
	verDoClean(actor) =
	{
		"That would be a colossal waste of time. ";
	}
	doBreak(actor) = {
		"You'll have to specify how exactly you want to do that. ";
	}
	verDoReplyto(actor) = {
		"I don't think <<self.thedesc>> asked you anything. ";
	}
	verDoTurn(actor) = { "Turning <<self.thedesc>> doesn't appear to have any effect. "; }
	verDoTurnWith(actor, iobj) = { self.verDoTurn(actor); }
	verDoTurnTo(actor, io) = { "Turning <<self.thedesc>> doesn't appear to have any effect. "; }
	verDoAskAbout(actor, io) = { "Oddly enough, you get no response. "; }
	verDoTellAbout(actor, io) = { "Oddly enough, you get no response. "; }
	verDoTalkto(actor) = { "Oddly enough, you get no response. "; }
	verIoShowTo(actor) = { "Oddly enough, you get no response. "; }
	verIoAttackWith(actor) = { "\^<<self.thedesc>> would make a rather dismal weapon. "; }
	verDoAttackWith(actor, io) = {
		if ((io = actor) || (io = hands))
			"Your fists do little damage. ";
		else
			"That would be pointless. ";
	}
	verDoEat(actor) = {
		"\^<<self.thedesc>> <<self.isdesc>> not quite edible. ";
	}
	verDoDrink(actor) = { "You can't drink <<self.thedesc>>. "; }
	smelldesc = {
		if (self.isThem)
			"\^<<self.thedesc>> smell about like you'd expect. ";
		else
			"\^<<self.thedesc>> smells about like you'd expect. ";
	}
	touchdesc = "\^<<self.thedesc>> feel<<self.verbs>> about like you'd expect. "
	doBurn(actor) = "You doubt that would burn well. "
	doThrowAt(actor, io) =
	{
		"\^<<self.thedesc>> bounce<<self.verbs>> off of <<io.thedesc>> and fall<<self.verbs>> to the ground. ";
		self.moveInto(actor.location);
	}
	doThrowTo(actor, io) =
	{
		"\^<<self.thedesc>> bounce<<self.verbs>> off of <<io.thedesc>> and fall<<self.verbs>> to the ground. ";
		self.moveInto(actor.location);
	}
	verDoPourOn(actor, io) = "But <<self.thedesc>> <<self.isdesc>> not a liquid! "
	verIoPourOn(actor) = {}
	ioPourOn(actor, dobj) = {
		dobj.doPourOn(actor, self);
	}
	verDoPourIn(actor, io) = "But <<self.thedesc>> <<self.isdesc>> not a liquid! "
	verIoPourIn(actor) = "But <<self.thedesc>> <<self.isdesc>> not a container! "
	verDoGreet(actor) = "You get no response from <<self.thedesc>>. "
	verIoPryWith(actor) = "You can't pry anything with <<self.thedesc>>. "
	ioPryWith(actor, dobj) = "Try as you might, you can't force <<dobj.thedesc>> open. "
	verDoPryWith(actor, io) = "You can't find any way to pry <<self.thedesc>>. "
	verDoHug(actor) = "\^<<self.thedesc>> does not return your feelings. "
	verDoScanWith(actor, iobj) = {}
	verDoScanOn(actor, iobj) = {}
	verIoScanOn(actor) = "You can't do that. "
	verDoScan(actor) = {}
	doScan(actor) = {
		askio(withPrep);
	}
	verbs = {
		if (!self.isThem)
			"s";
	}
	verbes = {
		if (!self.isThem)
			"es";
	}
	ldesc =	"You see nothing unusual about <<self.thedesc>>."
	verDoConcentrateon(actor) = {}
	doConcentrateon(actor) = "You feel like you've gained a deeper insight into <<self.thedesc>>. "
	actorAction(v, d, p, i) =
	{
		"You appear to have lost your mind. ";
		exit;
	}
	verDoLift(actor) = { self.verDoMove(actor); }
	doLift(actor) = "Lifting <<self.thedesc>> reveals nothing. "
	verDoMove(actor) = {}
	doMove(actor) = "Moving <<self.thedesc>> doesn't reveal anything. "
	verDoBraceWith(actor, iobj) = "You can't brace <<self.thedesc>>. "
	verIoBraceWith(actor) = "You can't brace anything with <<self.thedesc>>. "
;

// Not sure why this is here, since it's basically identical to adv.t
modify distantItem
	dobjGen(a, v, i, p) =
	{
		if (v <> inspectVerb and v <> askVerb and v <> tellVerb) {
			"\^<<self.itisdesc>> too far away.";
			exit;
		}
	}
;

// Added the concept of bulk, which is separate from weight.  Therefore, 
// something can be carryable (like an aluminum ladder) but far too large
// to fit in most containers.  Also applies to anything thin but long.
modify container
	ioPutIn(actor, dobj) =
	{
		if (dobj.bulk > self.bulkthresh) {
			"\^<<dobj.thatdesc>> won't fit in <<self.thedesc>>. ";
		} else if (addbulk(self.contents) + dobj.bulk > self.maxbulk) {
			"There's not enough room left in <<self.thedesc>> for <<dobj.thatdesc>>. ";
		} else {
			dobj.doPutIn(actor, self);
		}
	}
	verIoPourIn(actor) = "\^<<self.thedesc>> <<self.isdesc>> not waterproof! "
;

modify doorway
	destination =
	{
		if (self.isopen)
			return self.doordest;
		else if (not self.islocked and not self.noAutoOpen)
		{
			self.setIsopen(true);
			"(Opening << self.thedesc >>)\n";
			return self.doordest;
		}
		else
		{
			"%You%'ll have to open << self.thedesc >> first. ";
			setit(self);
			return nil;
		}
	}
	verDoPryWith(actor, io) = {
		if (self.islocked) {
			"Try as you might, you can't force <<self.thedesc>> open. ";
		} else {
			"That's not necessary.  It's not locked. ";
		}
	}
;

// I prefer to show the messages associated with the new state
modify switchItem
	doSwitch(actor) =
	{
		if (self.isActive)
			self.doTurnoff(actor);
		else
			self.doTurnon(actor);
	}
;

modify fixeditem
	verDoTake(actor) = { "\^<<self.thedesc>> won't budge. "; }
	verDoTurn(actor) = { "You can't get <<self.thedesc>> to turn. "; }
	verDoTurnTo(actor, io) = { "You can't get <<self.thedesc>> to turn. "; }
	verDoLift(actor) = { "You can't lift <<self.thedesc>>. "; }
;

modify Actor
	showActorDesc = true
	attacktime = -5
	itnomdesc = {
		if (self.isThem) {
			"they";
			return;
		}
		self.isHim ? "he" : self.isHer ? "she" : "it";
	}
	itobjdesc = {
		if (self.isThem) {
			"them";
			return;
		}
		self.isHim ? "him" : self.isHer ? "her" : "it";
	}
	itisdesc = {
		if (self.isThem) {
			"they're";
			return;
		}
		self.isHim ? "he's" : self.isHer ? "she's" : "it's";
	}
	itselfdesc = {
		if (self.isThem) {
			"themselves";
			return;
		}
		self.isHim ? "himself" : self.isHer ? "herself" : "itself";
	}
	// Hesitation built in for less cruel games
	verDoAttackWith(actor, io) = {}
	hesitatemsg = "You hesitate, realizing that such a course of action may not be entirely wise. "
	doAttack(weapon) = {
		if (global.turnsofar - self.attacktime > 5) {
			self.hesitatemsg;
			self.attacktime := global.turnsofar;
			exit;
		}
	}
	touchdesc = "That would be inappropriate. "
	verIoShowTo(actor) = {
		caps(); self.thedesc; " "; self.isntdesc; " impressed. ";
	}
	verDoRape(actor) = {}
	doRape(actor) = {
		"You doubt <<self.thedesc>> would appreciate that. ";
	}
	verDoScrew(actor) = {
		self.verDoRape(actor);
	}
	doScrew(actor) = {
		self.doRape(actor);
	}
	ioGiveTo(actor, dobj) =
	{
		"\^<<self.thedesc>> doesn't want <<dobj.thedesc>>.";
	}
	verDoGreet(actor) = {}
	doGreet(actor) = {
		self.actorAction(helloVerb, nil, nil, nil);
	}
	verIoPourOn(actor) = "That would be unnecessarily rude. "
	verDoTalkto(actor) = {}
	doTalkto(actor) = {
		"You pass the time with some brief small talk. ";
	}
	verDoHug(actor) = {}
	doHug(actor) = {
		"\^<<self.thedesc>> hugs you back. ";
	}
	verDoPush(actor) = "That would be rude. "
	verIoThrowAt(actor) = {
		local dobj = parserGetObj(PO_DOBJ);
		if (dobj != grenade)
			"That would probably just irritate <<self.fmtYoum>>. ";
	}
	verIoThrowTo(actor) = {
		local dobj = parserGetObj(PO_DOBJ);
		if (dobj != grenade)
			"That would probably just irritate <<self.fmtYoum>>. ";
	}
	verDoEat(actor) = "I don't think <<self.thedesc>> would agree with you. "
	verDoPoke(actor) = "That would be rude. "
	verDoKiss(actor) = "I don't think <<self.thedesc>> would appreciate that. "
	verDoPull(actor) = "That would be rude. "
	verDoMove(actor) = "That would be rude. "
;

// Standard scope includes floating items, but it does not include the
// contents of floating items which also happen to be containers.  This
// fixes that oversight.
modify deepverb
	validDoList(actor, prep, iobj) =
	{
		local ret;
		local loc;
	
		loc := actor.location;
		while (loc.location)
		loc := loc.location;
		ret := visibleList(actor, actor) + visibleList(loc, actor)
		+ global.floatingList + floatingItemContents();
		return ret;
	}
;

modify attackVerb
	verb = 'smash' 'bash' 'beat' 'club' 'strike'
	prepDefault = nil
	doAction = 'Attack'
;

modify putVerb
	verb = 'wedge' 'insert'
;

modify attachVerb
	verb = 'clip'
;

modify smellVerb
	action(actor) = {
		actor.location.smelldesc;
	}
;

modify openVerb
	verb = 'unfold' 'extend'
;

modify closeVerb
	verb = 'fold' 'retract'
;

modify throwVerb
	ioAction(inPrep) = 'PutIn'
;

modify theFloor
	verDoLookunder(actor) =
	{
		"That would be a neat trick. ";
	}
;

modify basicMe
	travelTo(dest) = {
		inherited.travelTo(dest);
		if (!isclass(dest, room))
			return;
		if (self.myfollower)
			self.myfollower.follow(self, self.location);
	}
	itnomdesc = "you"
	itobjdesc = "you"
	itisdesc = "you're"
	itselfdesc = "yourself"
	verDoRape(actor) = {
		"I'm not that kind of program. ";
	}
	verDoTake(actor) = {
		"You can't get a good enough grip. ";
	}
	verIoPourOn(actor) = "The idea of that disgusting water pouring all over you makes your skin crawl. "
	verDoEat(actor) = "Now now, no need to resort to cannibalism. "
;

// Previously, you couldn't remove a worn object if your hands were too 
// full to carry it.  This change makes the item drop to the floor.
modify clothingItem
	doUnwear(actor) =
	{
		/* ensure that maximum bulk is not exceeded */
		if (addbulk(actor.contents) + self.bulk > actor.maxbulk)
		{
			"Since %your% hands are too full to carry <<self.itobjdesc>>, you let it drop to the floor. ";
			self.moveInto(actor.location);
		}
		else
		{
			/* doff the item */
			"Okay, %you're% no longer wearing "; self.thedesc; ". ";
		}
		self.isworn := nil;
	}
;

// Allow some verbs to be done in dark rooms
modify iVerb
	isDarkVerb = true
;

modify yellVerb
	isDarkVerb = true
;

modify jumpVerb
	isDarkVerb = true
    action(actor) = { "You jump up and down."; }
;

modify askVerb
	isDarkVerb = true
;

modify tellVerb
	isDarkVerb = true
;

modify sayVerb
	validDo(actor, obj, seqno) = {
		return true;
	}
	validDoList(actor, prep, dobj) = (nil)
;

modify listenverb
	isDarkVerb = true
;

modify attackVerb
	doDefault(actor, prep, io) = {
		return [];
	}
;

modify standVerb
	verb = 'getout'
	isDarkVerb = true
;

modify typeVerb
	verb = 'type in'
	isDarkVerb = true
	validDo(actor, obj, seqno) =
	{
		return true;
	}
	validDoList(actor, prep, dobj) = (nil)
;

modify putVerb
	ioAction(underPrep) = 'PutUnder'
;

// The isKindaDarkVerb allows the verb in a dark room only under certain
// circumstances.  In this case, you can take one object out from inside 
// another that you are carrying.  Specifically, this prevents the game
// from becoming unwinnable when the player puts the flashlight into his
// pack.
modify takeVerb
	ioAction(withPrep) = 'TakeWith'
	isKindaDarkVerb = true
;

modify switchVerb
	isDarkVerb = true
;

modify turnOffVerb
	isDarkVerb = true
;

modify pushVerb
	ioAction(withPrep) = 'PushWith'
;

modify touchVerb
	verb = 'pet'
	ioAction(toPrep) = 'TouchTo'
	ioAction(withPrep) = 'TouchTo'
;

// Find an NPC to greet.  Otherwise, tell the player no one's there.
modify helloVerb
	action(actor) = {
		//askdo;
		local ret, rem, cur, rem2, cur2, tot, i, tot2, j, stat;

		ret := [];

		// Return all hide items
		rem := actor.location.contents;
		tot := length(rem);
		i := 1;
		while (i <= tot)
		{
			cur := rem[i];
			if (cur.isactor)
			{
				ret := ret + cur;
			}
			i := i + 1;
		}
		if (length(ret) = 0) {
			"There's no one here. ";
		} else if (length(ret) = 1) {
			execCommand(actor, greetVerb, ret[1]);
		} else {
			execCommand(actor, greetVerb, nil);
		}
	}
;

// Four major changes to the room class:
//   1. Room names appear in bold
//   2. Removed all indentations, which I've never cared for.  In effect,
//      this makes TADS room text blocks look like Inform (this may be
//      sacrilege, but I think it looks better).
//   3. A new property called "specialdesc" for rooms.  This is either a 
//      string or a method that returns a string.  It will be shown after
//      the ldesc and before actors or room contents are listed.  The
//      difference from normal ldesc text is that the specialdesc is also
//      displayed in brief mode.
//   4. Customizable contents listing.  Default is: You see <<>> here.
modify room
	dispParagraph = {
		global.dispParagraph;
	}
	dispBeginSdesc = "\("
	dispEndSdesc = "\)\n"
	dispBeginLdesc = ""
	specialdesc = nil
	lightsOn = true
	listContents = {
		"%You% see%s% "; listcont(self); " here. ";
	}
	nrmLkAround(verbosity) =        // lookAround without location status
	{
		local l, cur, i, tot;

		global.showedParagraph := true;
		if (verbosity)
		{
			self.dispBeginLdesc;
			self.ldesc;
			self.dispEndLdesc;
			global.showedParagraph := nil;
	
		} else {
			"\n";
		}

		global.spacer := true;
		if (self.specialdesc && (length(self.specialdesc)>0)) {
			global.showParagraph;
			global.showedParagraph := nil;
			"<<self.specialdesc>>";
		}
		if (!global.spacer) {
			global.showedParagraph := true;
		}			
	
		l := self.contents;
		tot := length(l);
		i := 1;
		while (i <= tot)
		{
			cur := l[i];
			if (cur.isfixed) {
				cur.heredesc;
			}
			i := i + 1;
		}

		if (itemcnt(self.contents))
		{
			if (!global.showedParagraph) {
				self.dispParagraph;
			}
			global.showedParagraph := true;
			self.listContents;
		}
		listcontcont(self);
//		"\n";
	
		l := self.contents;
		tot := length(l);
		i := 1;
		while (i <= tot)
		{
			cur := l[i];
			if (cur.isactor && cur.showActorDesc)
			{
				if (cur <> parserGetMe())
				{
					self.dispParagraph;
					cur.actorDesc;
				}
			}
			i := i + 1;
		}
//		"\n";
	}
	smelldesc = "You can't detect any appreciable odors. "
	floordesc = "It lies beneath %youm%. "
	noexit = {
		self.exitlist;
	}
;

modify darkroom
	darkmessage = "It's too dark to see. "
	darkdesc = "It's too dark to see. "
	lightsOn = nil
	lookAround(verbosity) =
	{
		if (self.islit)
			pass lookAround;
		else
			self.darkdesc;
	}
	roomCheck(v) =
	{
		if (self.islit or v.isDarkVerb or v.isKindaDarkVerb)
			return true;
		else
		{
			if (v = lookVerb)
				self.darkdesc;
			else
				"<<self.darkmessage>>\n";
			return nil;
		}
	}
	roomAction(actor, v, dobj, prep, io) =
	{
		if (actor != parserGetMe())
			return true;
		if (not self.islit and not v.isDarkVerb)
		{
			if (v = lookVerb) {
				self.darkdesc;
			} else if (v = takeVerb) {
				if (isinside(dobj, actor)) {
					inherited room.roomAction(actor, v, dobj, prep, io);
					return;
				} else
					self.darkmessage;
			} else {
				self.darkmessage;
			}
			exit;
		}
		else
			pass roomAction;
	}
	// The standard system of bad exits in TADS2 returns the "bad exit"
	// message even in a dark room.  This fixes that.
	badexit(text) = {
		if (self.islit) {
			say(text);
		} else {
			darkTravel();
		}
		return nil;
	}
	// If there's no defined exit in that direction, return the list of
	// exits.  In a dark room, print the standard dark travel text.
	noexit =
	{
		if (self.islit) {
			self.exitlist;
			return nil;
		} else {
			darkTravel();
			return nil;
		}
	}
;

modify fixeditem
	verDoPutUnder(actor, io) =
	{
		"%You% can't put "; self.thedesc; " anywhere. ";
	}
;

modify chairitem
	outOfPrep = "off of"
	statusPrep = "on"
;

// The change here is that 'look' no longer uses up a turn.  So no fuses
// or daemons advance.  However, 'look at/examine <object>' still burns a 
// turn.
modify lookVerb
	action(actor) = {
		actor.location.lookAround(true);
		abort;
	}
;

modify screwVerb
	doDefault(actor, prep, io) =
	{
		return nil;
	}
;

modify unscrewVerb
	doDefault(actor, prep, io) =
	{
		return nil;
	}
;

modify basicStrObj
	verDoSay(actor) =
	{
		"If you wish to speak to someone, you can address them directly.  For example: <B>JOHN, HELLO</B>";
	}
;

modify askVerb
	validDo(actor, obj, seqno) =
	{
		return obj.isVisible(actor);
	}
;

modify tellVerb
	validDo(actor, obj, seqno) =
	{
		return obj.isVisible(actor);
	}
;

/*
 *	Now, the new verbs
 */

pryVerb: deepverb
	verb = 'pry' 'lever' 'prise' 'jimmy' 'jemmy' 'prize' 'pry open' 'force open' 'lever open' 'prise open' 'jimmy open' 'jemmy open' 'prize open' 'force open'
	sdesc = "pry"
	ioAction(withPrep) = 'PryWith'
	prepDefault = withPrep
;

braceVerb: deepverb
	verb = 'brace' 'jam'
	sdesc = "brace"
	ioAction(withPrep) = 'BraceWith'
	prepDefault = withPrep
;

pourVerb: deepverb
	verb = 'pour' 'dump' 'splash'
	sdesc = "pour"
	prepDefault = onPrep
	ioAction(onPrep) = 'PourOn'
	ioAction(inPrep) = 'PourIn'
;

kissVerb: deepverb
	sdesc = "kiss"
	verb = 'kiss' 'smooch'
	doAction = 'Kiss'
;

swearVerb: deepverb
	verb = 'shit' 'shithead' 'cunt' 'bitch' 'dick' 'motherfucker' 'asshole' 'ass' 'dickhead' 'fuckhead' 'fucktard' 'fuckyou'
	sdesc = "swear"
	action(actor) = {
		"Profanity is the linguistic crutch of the inarticulate motherfucker. ";
	}
;

humpVerb: deepverb
	verb = 'rape' 'fuck' 'hump'
	sdesc = "rape"
	doAction = 'Rape'
	action(actor) = {
		"Profanity is the linguistic crutch of the inarticulate motherfucker. ";
	}
;

concentrateonVerb: darkVerb
	verb = 'concentrate on' 'meditate on'
	sdesc = "concentrate on"
	doAction = 'Concentrateon'
;

concentrateVerb: deepverb
	verb = 'concentrate' 'meditate'
	sdesc = "concentrate"
	action(actor) = {
		"You take a moment to collect your thoughts. ";
	}
;

diagnosisVerb: darkVerb
	verb = 'diagnosis' 'health' 'diagnose'
	sdesc = "diagnose"
	action(actor) = {
		"You are in perfect health. ";
	}
;

yesVerb: darkVerb
	verb = 'yes'
	sdesc = "yes"
	action(actor) = {
		"You sound very positive. ";
	}
;

noVerb: darkVerb
	verb = 'no'
	sdesc = "no"
	action(actor) = {
		"You sound very negative. ";
	}
;

creditsVerb: sysverb
	verb = 'credits'
	sdesc = "credits"
	action(actor) = {
		global.credits;
		abort;
	}
;

replyToVerb: deepverb
	verb = 'reply to' 'respond to' 'answer'
	sdesc = "reply to"
	doAction = 'Replyto'
;

replyVerb: deepverb
	verb = 'reply' 'respond'
	sdesc = "reply"
	action(actor) = {
		"If you wish to speak to someone, you can address them directly.  For example: <B>JOHN, HELLO</B>";
		abort;
	}
;

xyzzyVerb: darkVerb
	verb = 'xyzzy'
	sdesc = "xyzzy"
	action(actor) = {
		"Nothing happens. ";
	}
;

plughVerb: darkVerb
	verb = 'plugh'
	sdesc = "plugh"
	action(actor) = {
		"Nothing at all happens. ";
	}
;

ploverVerb: darkVerb
	verb = 'plover'
	sdesc = "plover"
	action(actor) = {
		"Nothing happens at all. ";
	}
;

greetVerb: deepverb
	verb = 'greet'
	sdesc = "greet"
	doAction = 'Greet'
;

hugVerb: deepverb
	verb = 'hug' 'comfort' 'embrace'
	sdesc = "hug"
	doAction = 'Hug'
;

talkVerb: darkVerb
	verb = 'talk to' 'speak with'
	sdesc = "talk to"
	doAction = 'Talkto'
	validDo(actor, obj, seqno) =
	{
		return obj.isVisible(actor);
	}
;

scanVerb: deepverb
	verb = 'scan' 'analyze'
	sdesc = "scan"
	prepDefault = withPrep
	doAction = 'Scan'
	ioAction(withPrep) = 'ScanWith'
	ioAction(onPrep) = 'ScanOn'
;

/*
 *	New functions
 */

// Prints a message and goes to endgame.  Pass true if the player died, or
// false if still alive.
lose: function(dead)
{
	if (dead)
		"\b\t**** You have died ****\b";
	else
		"\b\t**** You have failed ****\b";
	endgame(nil);
}

// Game is over.  Pass true if success, false if the player failed.  This
// function will loop until restore, quit, or restart.  Also, we quietly
// deduct 5 points if the player cheated. >:)
endgame: function(win)
{
	local resp;
	global.won := win;
	if (global.scCheated) {
		global.score -= 5;
	}
	scoreStatus(global.score, global.turnsofar);
	scoreRank();
	if (win)
		"\bYou may restore a saved game, start over, quit, itemize your points, read the author's notes, view amusing things to try, or undo the current command. ";
	else
		"\bYou may restore a saved game, start over, quit, itemize your points, or undo the current command. ";
	while (true)
	{
		if (win)
			"\nPlease enter RESTORE, RESTART, QUIT, FULL, NOTES, AMUSING, or UNDO: >";
		else
			"\nPlease enter RESTORE, RESTART, QUIT, FULL, or UNDO: >";
		resp := upper(input());
		if (resp = 'RESTORE')
		{
			resp := askfile('File to restore',
							ASKFILE_PROMPT_OPEN, FILE_TYPE_SAVE);
			if (resp = nil)
				"Restore failed. ";
			else if (restore(resp))
				"Restore failed. ";
			else
			{
				parserGetMe().location.lookAround(true);
				scoreStatus(global.score, global.turnsofar);
				abort;
			}
		}
		else if (resp = 'RESTART')
		{
			clearscreen();
			global.aboutbox;
			scoreStatus(0, 0);
			restart();
		}
		else if (resp = 'QUIT')
		{
			terminate();
			quit();
			abort;
		}
		else if (resp = 'UNDO')
		{
			if (undo())
			{
				"(Undoing one command)\b";
				parserGetMe().location.lookAround(true);
				scoreStatus(global.score, global.turnsofar);
				abort;
			}
			else
				"Sorry, no undo information is available. ";
		} else if (resp = 'FULL') {
			fullVerb.displayFull;
			"\b";
		} else if ((resp = 'NOTES') && win) {
			global.notes;
			"\b";
		} else if ((resp = 'AMUSING') && win) {
			global.amusing;
			"\b";
		}
	}
}

// Find the rank that corresponds to the player's current score.  These 
// ranks are strings stored as a list in global.ranks.
getRanking: function(score) {
	local i, m, n, z, scores, ranks;
	scores := global.gamescores;
	ranks := global.gameranks;
	z:=length(ranks);
	for (i:=1; i<=length(ranks); i++) {
		m := scores[i];
		n := ranks[i];
		if (score <= m) {
			return n;
		}
	}
	return global.ranks[length(global.ranks)];
}

replace scoreRank: function
{
	"In a total of <<global.turnsofar>> turns, you have achieved a score of <<global.score>> point";
	if (global.score != 1)
		"s";
	" out of a possible <<global.maxscore>>, giving you a rank of ";
	say(getRanking(global.score));
	".\n";
}

// Based on a source room (where some event has happened) and an observe
// room (generally, the location where the player is observing the event),
// returns a string based on the relative direction from observer to source.
// It does this by following standard room exits to see where the first link
// is found between source and observer.
findDirection: function(sourceroom, observeroom)
{
	local dirs, newloc, txt, i, tot, dir, pt, stat, room;
	// Done this way to prevent compiler warnings
	dirs := [] + &north + &south + &east + &west + &up + &down + &nw + &ne + &se + &sw;
	tot := length(dirs);
	stat := outcapture(true);
	for (i := 1 ; i <= tot ; ++i) {
		dir := dirs[i];
		newloc := observeroom.(dir);
		while (newloc != nil && newloc.isobstacle)
			newloc := newloc.doordest;
		if ((newloc != nil) && (newloc = sourceroom)) {
			txt := ['the north' 'the south' 'the east' 'the west' 'above' 'below' 'the northwest' 'the northeast' 'the southeast' 'the southwest'][i];
			outcapture(stat);
			return txt;
		}
	}
	outcapture(stat);
	return nil;
}

// Allow custom content messages
replace showcontcont: function(obj)
{
	if (itemcnt(obj.contents))
	{
		if (obj.issurface)
		{
			if (not obj.isqsurface)
			{
				global.showParagraph;
				obj.showsurface;
			}
		}
		else if (obj.contentsVisible and not obj.isqcontainer)
		{
			global.showParagraph;
			caps();
			obj.thedesc; " contain";
			if (!obj.isThem) "s";
			" ";
			listcont(obj);
			". ";
		}
	}
	if (obj.contentsVisible and not obj.isqcontainer)
		listfixedcontcont(obj);
}

// List of items contained in floating items, for scope reference
floatingItemContents: function()
{
	local obj, ret, i;
	ret := [];
	for (i:=1; i<=length(global.floatingList); i++) {
		obj := global.floatingList[i];
		if ((length(obj.contents) > 0) && obj.contentsVisible) {
			ret += obj.contents;
		}
	}
	return ret;
}

// Sends a message to every actor in a room when another actor does a
// significant action that requires a response.  Sort of an event pipeline.
informActors: function(actor, source, val)
{
	local cnt, tot, i, obj, j, list;

	if (val = 4)
		list := source.location.contents;
	else
		list := actor.location.contents;
	tot := length(list);
	for (i := 1, cnt := 0 ; i <= tot ; ++i)
	{
		obj := list[i];
		if (isclass(obj,movableActor) && (obj != actor)) {
			obj.announce(actor, source, val);
		}
	}

}

// Locate the root room of the specified object.  Recurses through nested
// containers until it finds one with isRoom set true.
findRootRoom: function(vantage)
{
	if (vantage = nil)
		return nil;
	if ((vantage.location = nil) || (vantage.isRoom))
		return vantage;
	return findRootRoom(vantage.location);
}

// Return true if obj is in list.
inList: function(obj, list)
{
	local i;
	for (i:=1;i<=length(list);i++) {
		if (list[i] = obj)
			return true;
	}
	return nil;
}

// Increase score and set up a notify so that a message is shown to the 
// player just before the next cursor.
replace incscore: function( amount )
{
    global.score += amount;
    scoreStatus(global.score, global.turnsofar);
    global.addthis += amount;
    if (global.notified)
		notify(global,&tellscore,1);
}

// A notify set by another notify will NOT be called until the end of the
// NEXT turn.  So in cases where incscore was called from a daemon or notify
// or fuse, this should be called soon afterwards.
doScoreNotify: function()
{
	if (global.addthis != 0) {
		unnotify(global,&tellscore);
		global.tellscore;
	}
}

/*
 *	New Classes
 */

// A fairly crude liquid class
class liquid: item
	isliquid = true
	verDoPourOn(actor, io) = {}
	verDoPourIn(actor, io) = {}
	verDoDrink(actor) = {}
	doPourOn(actor, io) = {
		"%You% pour <<self.thedesc>> all over <<io.thedesc>>, thoroughly wetting <<io.itobjdesc>>. ";
		self.moveInto(nil);
	}
	doDrink(actor) =
	{
		"That was delicious! ";
		self.moveInto(nil);
	}
	doPutOn(actor, io) = {
		self.doPourOn(actor, io);
	}
;

class iron: item
	isiron = true
;

class paper: item
	ispaper = true
	doThrowAt(actor, io) =
	{
		"\^<<self.thedesc>> flutters to the ground. ";
		self.moveInto(actor.location);
	}
	doThrowTo(actor, io) =
	{
		"\^<<self.thedesc>> flutters to the ground. ";
		self.moveInto(actor.location);
	}
;

// Didn't use the standard decoration class because I wanted some of the 
// verification messages to be customizable.  Also allows simple 
// floatingitems to be defined by storing a list of rooms in the locations 
// property
class scenery: fixeditem
	location = {
		local i;
		if (length(self.locations) = 0)
			return nil;
		for (i:=1; i<=length(self.locations); i++) {
			if (findRootRoom(parserGetMe()) = self.locations[i])
				return self.locations[i];
		}
		return nil;
	}
	scenerymessage = "You realize that fiddling with <<self.thedesc>> isn't necessary. "
	verDoAttachTo(actor, iobj) = { self.scenerymessage; }
	verIoAttachTo(actor) = { self.scenerymessage; }
	verDoDetach(actor) = { self.scenerymessage; }
	verDoDetachFrom(actor, iobj) = { self.scenerymessage; }
	verIoDetachFrom(actor) = { self.scenerymessage; }
	verDoWear(actor) = { self.scenerymessage; }
	verDoTake(actor) = { self.scenerymessage; }
	verDoDrop(actor) = { self.scenerymessage; }
	verIoPutIn(actor) = { self.scenerymessage; }
	verDoPutIn(actor, io) = { self.scenerymessage; }
	verIoPutOn(actor) = { self.scenerymessage; }
	verIoPlugIn(actor) = { self.scenerymessage; }
	verDoPlugIn(actor, io) = { self.scenerymessage; }
	verDoUnplugFrom(actor, io) = { self.scenerymessage; }
	verDoTurn(actor) = { self.scenerymessage; }
	verDoTurnWith(actor, io) = { self.scenerymessage; }
	verDoTurnTo(actor, io) = { self.scenerymessage; }
	verDoTurnon(actor) = { self.scenerymessage; }
	verDoTurnoff(actor) = { self.scenerymessage; }
	verDoAskAbout(actor, io) = { self.scenerymessage; }
	verDoTellAbout(actor, io) = { self.scenerymessage; }
	verDoAttackWith(actor, io) = { self.scenerymessage; }
	verDoAttack(actor) = { self.scenerymessage; }
	verDoPull(actor) = { self.scenerymessage; }
	verDoPush(actor) = { self.scenerymessage; }
	verIoShowTo(actor) = { self.scenerymessage; }
	verDoClean(actor) = { self.scenerymessage; }
	verDoMove(actor) = { self.scenerymessage; }
	verDoMoveWith(actor, io) = { self.scenerymessage; }
	verDoBreak(actor) = { self.scenerymessage; }
	verDoTouch(actor) = { self.scenerymessage; }
;

// This is for creating a scenery item to represent the entire room.  For
// example, a player may refer to 'clearing' or 'hallway' in a command and
// mean the entire room the player is currently in.
class sceneryroom: scenery
	ldesc = { location.ldesc; }
	listendesc = { location.listendesc; }
	smelldesc = { location.smelldesc; }
	scenerymessage = "That doesn't appear to be possible. "
	verDoSearch(actor) = "You'll need to be more specific how you want to do that. "
	ioThrowAt(actor, dobj) =
	{
	        dobj.doDrop(actor);
	}
	verIoPutIn(actor) = {}
	ioPutIn(actor, dobj) = {
	        dobj.doDrop(actor);
	}
	verIoPutOn(actor) = {}
	ioPutOn(actor, dobj) = {
	        dobj.doDrop(actor);
	}
	verDoEnter(actor) = "You're already inside of it. "
;

// Like a switchItem, except not fixed.  Can be turned on, off, or
// switched to toggle current state.
class switchItemNotFixed: item
	verDoSwitch(actor) =
	{
		/*
		 *   You can't turn on something in the dark unless you're
		 *   carrying it.  You also can't turn something on if it's
		 *   already on.  
		 */
		if (not actor.location.islit and not actor.isCarrying(self))
			"It's pitch black. ";
	}
	doSwitch(actor) =
	{
		if (self.isActive)
			self.doTurnoff(actor);
		else
			self.doTurnon(actor);
	}
	verDoTurnon(actor) =
	{
		/*
		 *   You can't turn on something in the dark unless you're
		 *   carrying it.  You also can't turn something on if it's
		 *   already on.  
		 */
		if (not actor.location.islit and not actor.isCarrying(self))
			"It's pitch black. ";
		else if (self.isActive)
			"\^<<self.itisdesc>> already turned on! ";
	}
	doTurnon(actor) =
	{
		self.isActive := true;
		"Okay, "; self.thedesc; " <<self.isdesc>> now switched on. ";
	}
	verDoTurnoff(actor) =
	{
		if (not self.isActive)
			"\^<<self.itisdesc>> already turned off! ";
	}
	doTurnoff(actor) =
	{
		self.isActive := nil;
		"Okay, "; self.thedesc; " <<self.isdesc>> now switched off. ";
	}
	verDoUse(actor) = { self.verDoSwitch(actor); }
	doUse(actor) = { self.doSwitch(actor); }
;

// A light source that can be carried and turned on and off.
class switchLightItemNotFixed: switchItemNotFixed
	doTurnon(actor) =
	{
		local waslit := actor.location.islit;
		self.isActive := true;
		self.islit := true;
		"Okay, <<self.itisdesc>> now turned on. ";
		if (actor.location.islit and not waslit)
		{
			"<<global.dispParagraph>>";
			actor.location.isseen := nil;
			actor.location.lookAround(true);
		}
	}
	doTurnoff(actor) =
	{
		self.isActive := nil;
		self.islit := self.isActive;
		"Okay, "; self.thedesc; " <<self.isdesc>> now switched off. ";
		if (not actor.location.islit)
			"It's now pitch black. ";
	}
	verDoUse(actor) = { self.verDoSwitch(actor); }
	doUse(actor) = { self.doSwitch(actor); }
;

// Honestly, can't remember why this is here or if things will break
// if I remove it.  It looks like whatever I was planning to do with it
// was later removed.  Seems harmless enough to leave in though.
parseErrorParam: function(errnum, str, ...) {
	local i, arglist, dobj;
	dobj := parserGetObj(PO_DOBJ);
	arglist := [];
	for (i:=1; i<=argcount; i++) {
		arglist += [ getarg(i) ];
	}
	return nil;
}
